﻿using System;
using System.Windows.Forms;

namespace ORA11
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Text = "Gyakorlás";
            label1.Text = "a";
            label2.Text = "b";
            label3.Text = "";
            button1.Text = "Fgv";
            button2.Text = "Prím";
            button3.Text = "Keresztszorzat";
            button4.Text = "Keresztszorzat";
        }

        double fgv(double a, double b)
        {
            double eredmeny = Math.Exp(Math.Sqrt(b) / a) * 4 / 3.0;
            if (a != 0 && b >= 0)
                return eredmeny;
            else
                return Double.NaN;
        }
        private void button1_Click(object sender, EventArgs e)
        {
            double a = Convert.ToDouble(textBox1.Text);
            double b = Convert.ToDouble(textBox2.Text);

            double x = fgv(a, b);

            if (Double.IsNaN(x) || Double.IsInfinity(x))
                label3.Text = "Nincs megoldás";
            else
                label3.Text = x.ToString("F3");
        }

        bool IsPrime(int szam)
        {
            szam = Math.Abs(szam);
            if(szam <= 1) return false;
            for (int i = 2; i <= Math.Sqrt(szam); i++)
                if (szam % i == 0) return false;
            return true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int szam = Convert.ToInt32(textBox1.Text);
            bool prim = IsPrime(szam);
            if (prim)
                label3.Text = "Prím";
            else
                label3.Text = "Nem prím";
        }

        double[] keresztszorzat(double[] Fa, double[] Fb)
        {
            double[] eredmeny = new double[3];
            eredmeny[0] = Fa[1] * Fb[2] - Fa[2] * Fb[1];
            eredmeny[1] = Fa[2] * Fb[0] - Fa[0] * Fb[2];
            eredmeny[2] = Fa[0] * Fb[1] - Fa[1] * Fb[0];
            return eredmeny;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            double[] Fa = new double[3];
            double[] Fb = new double[3];

            Fa[0] = 1;
            Fa[1] = 0;
            Fa[2] = 0;

            Fb[0] = 0;
            Fb[1] = 1;
            Fb[2] = 0;

            double[] Fe = new double[3];
            for (int i = 0; i < 3; i++)
                Fe[i] = Fa[i] + Fb[i];

            //keresztszorzat
            Fe = keresztszorzat(Fa, Fb);
        }

        public class p3D
        {
            public double x;
            public double y;
            public double z;
        }

        p3D keresztszorzat(p3D Fa, p3D Fb)
        {
            p3D Fe = new p3D();
            Fe.x = Fa.y * Fb.z - Fa.z * Fb.y;
            Fe.y = Fa.z * Fb.x - Fa.x * Fb.z;
            Fe.z = Fa.x * Fb.y - Fa.y * Fb.x;
            return Fe;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            p3D Fa = new p3D();
            p3D Fb = new p3D();

            Fa.x = 1;
            Fa.y = 0;
            Fa.z = 0;

            Fb.x = 0;
            Fb.y = 1;
            Fb.z = 0;

            p3D Fe = new p3D();
            Fe.x = Fa.x + Fb.x;
            Fe.y = Fa.y + Fb.y;
            Fe.z = Fa.z + Fb.z;

            //keresztszorzat
            Fe = keresztszorzat(Fa, Fb);
        }
    }
}
